#include "typedef.h"

#include <assert.h>
#include <string.h>
#include <stdio.h>

#include "xmalloc.h"
#include "util.h"
#include "object.h"
#include "code.h"
#include "source.h"
#include "class.h"

Cclass	*Cclass::g_class_hash[HASHSIZE] = {0};

/* static */ u4T
Cclass::hash(const u2T *nameP)
{
	int		ret  = 0;
	u2T		c;
	const	u2T *P;

	for (P = nameP; (c = *P) ; ++P) {
		ret  += c;
		ret <<= 1;
		if (ret & HASHSIZE) {
			ret |= 1;
	}	}
	return(ret & (HASHSIZE-1));
}

Cclass::Cclass(void)
{
	memset(this, 0, sizeof(Cclass));
}

Cclass *
Cclass::locate(stringT *nameP)
{
	unsigned int	index;
	Cclass			*classP;
	Cclass			**classPP;

	index = hash(nameP->P);
	for (classPP = g_class_hash + index; ; classPP = &(classP->m_hashP)) {
		if (!(classP = *classPP)) {
			classP = new Cclass();
			if (!classP) {
				outofmemory();
			}
			*classPP = classP;	// Add to hash list
			classP->m_nameP = nameP;
			break;
		}
		if (classP->m_nameP->P == nameP->P) {
			break;
	}	}
	return(classP);
}

// This is called when the class name is mangled

#if 0
Cclass *
Cclass::locate_mangled(stringT *stringP)
{
	u2T				*nameP;
	Csource			*classP;
	u2T				*P;
	u2T				c;

	for (nameP = stringP->P; *nameP == '['; ++nameP); // ignore array subscripts on class
	if (*nameP == 'L') {
		++nameP;	// Advance nameP so avoids 'L' at start
	} else {
		// Not a class name but a primative data type
		if (!nameP[1]) {
			switch(*nameP) {
			case 'B':
			case 'C':
			case 'D':
			case 'F':
			case 'I':
			case 'J':
			case 'S':
			case 'Z':
				return(0);
	}	}	}

	for (P = nameP; (c = *P); ++P) {
		if (c == ';') {
			break;
	}	}
	*P = 0;		// Remove trailing ';'
	classP = locate(nameP);
	*P = c; // Put the name back the way it was
	return(classP);
}
#endif

extern FILE *taF;
extern FILE	*tempF;

void
Cclass::emit_ta(void)
{
	Csource	*sourceP;

	sourceP = m_sourceP;
	if (!sourceP->m_has_clones) {
		sourceP->m_has_clones = 1;
		sourceP->emit_ta();
	}

	fprintf(taF, "$INSTANCE C%p C\n", this);
	fprintf(taF, "contain S%p C%p\n", sourceP, this);
	fprintf(tempF, "C%p {label=\"", this);
	dump_wchar(m_nameP->P, tempF);
	fprintf(tempF, "\" file=\".\"");
	fputs("}\n", tempF);
}
