
struct codeS;
class Cfunction;

typedef enum {
	NOP					= 0x00,
	MOVE_4_4			= 0x01,
	MOVE_8_16			= 0x02,
	MOVE_16_16			= 0x03,
	MOVE_WIDE_4_4		= 0x04,
	MOVE_WIDE_8_16		= 0x05,
	MOVE_WIDE_16_16		= 0x06,
	MOVE_OBJECT_4_4		= 0x07, 
	MOVE_OBJECT_8_16	= 0x08,
	MOVE_OBJECT_16_16	= 0x09,
	MOVE_RESULT			= 0x0a,
	MOVE_RESULT_WIDE	= 0x0b,
	MOVE_RESULT_OBJECT	= 0x0c,
	MOVE_EXCEPTION		= 0x0d,
	RETURN_VOID			= 0x0e,
	RETURN				= 0x0f,
	RETURN_WIDE			= 0x10,
	RETURN_OBJECT		= 0x11,
	CONST_4_4			= 0x12,
	CONST_8_16			= 0x13,
	CONST_8_32			= 0x14,
	CONST_HIGH			= 0x15,
	CONST_WIDE_8_16     = 0x16,
	CONST_WIDE_8_32     = 0x17,
	CONST_WIDE_8_64		= 0x18,	
	CONST_WIDE_HIGH		= 0x19,
	CONST_STRING_8_16	= 0x1a,
	CONST_STRING_8_32	= 0x1b,
	CONST_CLASS			= 0x1c,
	MONITOR_ENTER		= 0x1d,
	MONITOR_EXIT		= 0x1e,
	CHECK_CAST			= 0x1f,
	INSTANCE_OF			= 0x20,
	ARRAY_LENGTH		= 0x21,
	NEW_INSTANCE		= 0x22,
	NEW_ARRAY			= 0x23,
	FILL_ARRAY			= 0x24,
	FILLED_NEW_ARRAY	= 0x25,
	FILL_ARRAY_DATA		= 0x26,
	THROW				= 0x27,
	GOTO_8				= 0x28,
	GOTO_16				= 0x29,
	GOTO_32				= 0x2a,
	PACKED_SWITCH		= 0x2b,
	SPARSE_SWITCH		= 0x2c,
	CMPL_FLOAT			= 0x2d,
	CMPG_FLOAT			= 0x2e,
	CMPL_DOUBLE			= 0x2f,
	CMPG_DOUBLE			= 0x30,
	CMP_LONG			= 0x31,
	IF_EQ				= 0x32,
	IF_NE				= 0x33,
	IF_LT				= 0x34,
	IF_GE				= 0x35,
	IF_GT				= 0x36,
	IF_LE				= 0x37,
	IF_EQ_ZERO			= 0x38,
	IF_NE_ZERO			= 0x39,
	IF_LT_ZERO			= 0x3a,
	IF_GE_ZERO			= 0x3b,
	IF_GT_ZERO			= 0x3c,
	IF_LE_ZERO			= 0x3d,
	BAD_3E				= 0x3e,
	BAD_3F				= 0x3f,
	BAD_40				= 0x40,
	BAD_41				= 0x41,
	BAD_42				= 0x42,
	BAD_43				= 0x43,
	AGET				= 0x44,
	AGET_WIDE			= 0x45,
	AGET_OBJECT			= 0x46,
	AGET_BOOLEAN		= 0x47,
	AGET_BYTE			= 0x48,
	AGET_CHAR			= 0x49,
	AGET_SHORT			= 0x4a,
	APUT				= 0x4b,
	APUT_WIDE			= 0x4c,
	APUT_OBJECT			= 0x4d,
	APUT_BOOLEAN		= 0x4e,
	APUT_BYTE			= 0x4f,
	APUT_CHAR			= 0x50,
	APUT_SHORT			= 0x51,
	IGET				= 0x52,
	IGET_WIDE			= 0x53,
	IGET_OBJECT			= 0x54,
	IGET_BOOLEAN		= 0x55,
	IGET_BYTE			= 0x56,
	IGET_CHAR			= 0x57,
	IGET_SHORT			= 0x58,
	IPUT				= 0x59,
	IPUT_WIDE			= 0x5a,
	IPUT_OBJECT			= 0x5b,
	IPUT_BOOLEAN		= 0x5c,
	IPUT_BYTE			= 0x5d,
	IPUT_CHAR			= 0x5e,
	IPUT_SHORT			= 0x5f,
	STATIC_GET			= 0x60,
	STATIC_GET_WIDE		= 0x61,
	STATIC_GET_OBJECT	= 0x62,
	STATIC_GET_BOOLEAN	= 0x63,
	STATIC_GET_BYTE		= 0x64,
	STATIC_GET_CHAR		= 0x65,
	STATIC_GET_SHORT	= 0x66,
	STATIC_PUT			= 0x67,
	STATIC_PUT_WIDE		= 0x68,
	STATIC_PUT_OBJECT	= 0x69,
	STATIC_PUT_BOOLEAN	= 0x6a,
	STATIC_PUT_BYTE		= 0x6b,
	STATIC_PUT_CHAR		= 0x6c,
	STATIC_PUT_SHORT	= 0x6d,
	INVOKE_VIRTUAL		= 0x6e,
	INVOKE_SUPER		= 0x6f,
	INVOKE_DIRECT		= 0x70,
	INVOKE_STATIC		= 0x71,
	INVOKE_INTERFACE	= 0x72,
	BAD_73				= 0x73,
	INVOKE_VIRTUAL_RANGE= 0x74,
	INVOKE_SUPER_RANGE	= 0x75,
	INVOKE_DIRECT_RANGE	= 0x76,
	INVOKE_STATIC_RANGE	= 0x77,
	INVOKE_INTERFACE_RANGE=0x78,
	BAD_79				= 0x79,
	BAD_7A				= 0x7A,
	NEG_INT				= 0x7b,
	NOT_INT				= 0x7c,
	NEG_LONG			= 0x7d,
	NOT_LONG			= 0x7e,
	NEG_FLOAT			= 0x7f,
	NEG_DOUBLE			= 0x80,
	INT_TO_LONG			= 0x81,
	INT_TO_FLOAT		= 0x82,
	INT_TO_DOUBLE		= 0x83,
	LONG_TO_INT			= 0x84,
	LONG_TO_FLOAT		= 0x85,
	LONG_TO_DOUBLE		= 0x86,
	FLOAT_TO_INT		= 0x87,
	FLOAT_TO_LONG		= 0x88,
	FLOAT_TO_DOUBLE		= 0x89,
	DOUBLE_TO_INT		= 0x8a,
	DOUBLE_TO_LONG		= 0x8b,
	DOUBLE_TO_FLOAT		= 0x8c,
	INT_TO_BYTE			= 0x8d,
	INT_TO_CHAR			= 0x8e,
	INT_TO_SHORT		= 0x8f,
	ADD_INT				= 0x90,
	SUB_INT				= 0x91,
	MUL_INT				= 0x92,
	DIV_INT				= 0x93,
	REM_INT				= 0x94,
	AND_INT				= 0x95,
	OR_INT				= 0x96,
	XOR_INT				= 0x97,
	SHIFT_LEFT_INT		= 0x98,
	SHIFT_RIGHT_INT		= 0x99,
	USHIFT_RIGHT_INT	= 0x9a,
	ADD_LONG			= 0x9b,
	SUB_LONG			= 0x9c,
	MUL_LONG			= 0x9d,
	DIV_LONG			= 0x9e,
	REM_LONG			= 0x9f,
	AND_LONG			= 0xa0,
	OR_LONG				= 0xa1,
	XOR_LONG			= 0xa2,
	SHIFT_LEFT_LONG		= 0xa3,
	SHIFT_RIGHT_LONG	= 0xa4,
	USHIFT_RIGHT_LONG	= 0xa5,
	ADD_FLOAT			= 0xa6,
	SUB_FLOAT			= 0xa7,
	MUL_FLOAT			= 0xa8,
	DIV_FLOAT			= 0xa9,
	REM_FLOAT			= 0xaa,
	ADD_DOUBLE			= 0xab,
	SUB_DOUBLE			= 0xac,
	MUL_DOUBLE			= 0xad,
	DIV_DOUBLE			= 0xae,
	REM_DOUBLE			= 0xaf,
	ADD_INT2			= 0xb0,
	SUB_INT2			= 0xb1,
	MUL_INT2			= 0xb2,
	DIV_INT2			= 0xb3,
	REM_INT2			= 0xb4,
	AND_INT2			= 0xb5,
	OR_INT2				= 0xb6,
	XOR_INT2			= 0xb7,
	SHIFT_LEFT_INT2		= 0xb8,
	SHIFT_RIGHT_INT2	= 0xb9,
	USHIFT_RIGHT_INT2	= 0xba,
	ADD_LONG2			= 0xbb,
	SUB_LONG2			= 0xbc,
	MUL_LONG2			= 0xbd,
	DIV_LONG2			= 0xbe,
	REM_LONG2			= 0xbf,
	AND_LONG2			= 0xc0,
	OR_LONG2			= 0xc1,
	XOR_LONG2			= 0xc2,
	SHIFT_LEFT_LONG2	= 0xc3,
	SHIFT_RIGHT_LONG2	= 0xc4,
	USHIFT_RIGHT_LONG2	= 0xc5,
	ADD_FLOAT2			= 0xc6,
	SUB_FLOAT2			= 0xc7,
	MUL_FLOAT2			= 0xc8,
	DIV_FLOAT2			= 0xc9,
	REM_FLOAT2			= 0xca,
	ADD_DOUBLE2			= 0xcb,
	SUB_DOUBLE2			= 0xcc,
	MUL_DOUBLE2			= 0xcd,
	DIV_DOUBLE2			= 0xce,
	REM_DOUBLE2			= 0xcf,
	ADD_INT_LIT16		= 0xd0,
	REVERSE_SUB_INT_LIT16= 0xd1,
	MUL_INT_LIT16		= 0xd2,
	DIV_INT_LIT16		= 0xd3,
	REM_INT_LIT16		= 0xd4,
	AND_INT_LIT16		= 0xd5,
	OR_INT_LIT16		= 0xd6,
	XOR_INT_LIT16		= 0xd7,
	ADD_INT_LIT8		= 0xd8,
	REVERSE_SUB_INT_LIT8= 0xd9,
	MUL_INT_LIT8		= 0xda,
	DIV_INT_LIT8		= 0xdb,
	REM_INT_LIT8		= 0xdc,
	AND_INT_LIT8		= 0xdd,
	OR_INT_LIT8			= 0xde,
	XOR_INT_LIT8		= 0xdf,
	SHIFT_LEFT_INT_LIT8 = 0xe0,
	SHIFT_RIGHT_INT_LIT8= 0xe1,
	USHIFT_RIGHT_INT_LIT8=0xe2,
	BAD_E3				= 0xe3,
 	BAD_E4				= 0xe4,
	BAD_E5				= 0xe5,
	BAD_E6				= 0xe6,
	BAD_E7				= 0xe7,
	BAD_E8				= 0xe8,
	BAD_E9				= 0xe9,
	BAD_EA				= 0xea,
	BAD_EB				= 0xeb,
	BAD_EC				= 0xec,
	BAD_ED				= 0xed,
	BAD_EE				= 0xee,
	BAD_EF				= 0xef,
	BAD_F0				= 0xf0,
	BAD_F1				= 0xf1,
	BAD_F2				= 0xf2,
	BAD_F3				= 0xf3,
 	BAD_F4				= 0xf4,
	BAD_F5				= 0xf5,
	BAD_F6				= 0xf6,
	BAD_F7				= 0xf7,
	BAD_F8				= 0xf8,
	BAD_F9				= 0xf9,
	BAD_FA				= 0xfa,
	BAD_FB				= 0xfb,
	BAD_FC				= 0xfc,
	BAD_FD				= 0xfd,
	BAD_FE				= 0xfe,
	BAD_FF				= 0xff,

	TRY_END				= 0xFE,	// Special (order important)
	TRY_START			= 0xFF	// Special
} pcodeE;

typedef struct {
	// index into the string_ids list for the short-form descriptor string of this prototype. 
	// The string must conform to the syntax for ShortyDescriptor, defined above, and must correspond to the return type and parameters of this item.  
	stringT		*shortyP;
	// index into the type_ids list for the return type of this prototype  
	stringT		*return_typeP;
	// Number of parameters or 0 if this prototype has 0 parameters or -1 if has no type list
	s4T			parameters;
	// Array of index into the type_ids list 
	stringT		**parametersPP;
} protoT;

typedef struct {
	// index into the type_ids list for the definer of this field. This must be a class type, and not an array or primitive type. 
	stringT			*classP;
	// index into the type_ids list for the type of this field  
	stringT			*typeP;
	// index into the string_ids list for the name of this field. The string must conform to the syntax for MemberName, defined above.
	stringT			*nameP;
} fieldT;

typedef struct {
	// index into the type_ids list for the definer of this method. This must be a class or array type, and not a primitive type.
	stringT			*classP;
	// index into the proto_ids list for the prototype of this method  
	protoT			*protoP;
	// index into the string_ids list for the name of this method. The string must conform to the syntax for MemberName, defined above. 
	stringT			*nameP;
} methodT;

typedef struct {
	u4T	register_num;
	stringT	*nameP;
	stringT	*typeP;
	stringT	*sigP;
	u4T	start_address;
	u4T	end_address;
} variableT;

typedef struct {
	u4T			number;
	union {
		variableT	*variableP;		// If a register
		stringT		*stringP;		// If a string
		stringT		*typeP;			// If a type
		fieldT		*fieldP;		// If a field
		methodT		*methodP;		// If a method
	} u;
} registerT;

typedef struct {
	registerT	reg1;
} info_register1T;

typedef struct {
	registerT	reg1;
	registerT	reg2;
} info_register2T;

typedef struct {
	registerT	reg1;
	registerT	reg2;
	registerT	reg3;
} info_register3T;

typedef struct {
	registerT	last;
	u4T			size;
	registerT	reg[1];	// Variable length
} info_registersT;

typedef struct {
	u4T			to;
	registerT	classtype;
} info_tryT;

typedef struct {
	registerT	reg1;
	u4T			width;
	u4T			entries;
	u1T			data[1];	// Variable length
} info_fillT;

typedef struct {
	registerT	reg1;
	s4T			value;
} info_valueT;

typedef struct {
	registerT	reg1;
	registerT	reg2;
	s4T			value;
} info_value2T;

typedef struct {
	registerT	reg1;
	s8T			value;
} info_wideT;

typedef union {
	u1T				*P;
	info_register1T	*register1P;
	info_register2T *register2P;
	info_register3T *register3P;
	info_registersT	*registersP;
	info_fillT		*fillP;
	info_valueT		*valueP;
	info_value2T	*value2P;
	info_wideT		*wideP;
	info_tryT		*tryP;
} infoT;

typedef union {
	int				offset;
	struct	codeS	*P;
} jumpT;

class Cfile;

typedef struct {
	u4T		address;		// The instruction offset in the associated insns_item in 16-bit code units
	Cfile	*source_fileP;	// Source file at this line
	s4T		line;			// The line register represents what source line number should be associated with the next positions table entry emitted by the state machine. 
#define Prologue_endX	0x01
#define Epilogue_beginX	0x02
	u4T		flags;			// boolean flags that indicate whether the next position emitted should be considered a method prologue.
} positionT;

typedef struct codeS {
	struct codeS	*m_hashP;			// The next candidate same instruction
	Cfunction		*m_functionP;		// The function this code belongs to
	struct codeS	*m_matchP;			// The matching instruction else 0
	u4T				m_pc;				// The program counter
	positionT		*m_positionP;		// Position in source file
	pcodeE			m_pcode;			// Instruction type
	infoT			info;
	jumpT			m_jump;
} codeT;

