#include "typedef.h"
#include "opcode.h"

const char	*opcodes[] = {
/* 00 */	"nop",
/* 01 */	"move",
/* 02 */	"move",
/* 03 */	"move",
/* 04 */	"move-wide",
/* 05 */	"move-wide",
/* 06 */	"move-wide",
/* 07 */	"move-object",
/* 08 */	"move-object",
/* 09 */	"move-object",
/* 0a */	"move-result",
/* 0b */	"move-result-wide",
/* 0c */	"move-result-object",
/* 0d */	"move-exception",
/* 0e */	"return-void",
/* 0f */	"return",
/* 10 */	"return-wide",
/* 11 */	"return-object",
/* 12 */	"const",
/* 13 */	"const",
/* 14 */	"const",
/* 15 */	"const",
/* 16 */	"const-wide",
/* 17 */	"const-wide",
/* 18 */	"const-wide",
/* 19 */	"const-wide",
/* 1a */	"const-string",
/* 1b */	"const-string/jumbo",
/* 1c */	"const-class",
/* 1d */	"monitor-enter",
/* 1e */	"monitor-exit",
/* 1f */	"check-cast",
/* 20 */	"instance-of",
/* 21 */	"array-length",
/* 22 */	"new-instance",
/* 23 */	"new-array",
/* 24 */	"filled-new-array",
/* 25 */	"filled-new-array/range",
/* 26 */	"fill-array-data",
/* 27 */	"throw",
/* 28 */	"goto",
/* 29 */	"goto/16",
/* 2a */	"goto/32",
/* 2b */	"packed-switch",
/* 2c */	"sparse-switch",
/* 2d */	"cmpl-float",
/* 2e */	"cmpg-float",
/* 2f */	"cmpl-double",
/* 30 */	"cmpg-double",
/* 31 */	"cmp-long",
/* 32 */	"if-eq",
/* 33 */	"if-ne",
/* 34 */	"if-lt",
/* 35 */	"if-ge",
/* 36 */	"if-gt",
/* 37 */	"if-le",
/* 38 */	"if-eqz",
/* 39 */	"if-nez",
/* 3a */	"if-ltz",
/* 3b */	"if-gez",
/* 3c */	"if-gtz",
/* 3d */	"if-lez",
/* 3e */	0,
/* 3f */	0,
/* 40 */	0,
/* 41 */	0,
/* 42 */	0,
/* 43 */	0,
/* 44 */	"aget",
/* 45 */	"aget-wide",
/* 46 */	"aget-object",
/* 47 */	"aget-boolean",
/* 48 */	"aget-byte",
/* 49 */	"aget-char",
/* 4a */	"aget-short",
/* 4b */	"aput",
/* 4c */	"aput-wide",
/* 4d */	"aput-object",
/* 4e */	"aput-boolean",
/* 4f */	"aput-byte",
/* 50 */	"aput-char",
/* 51 */	"aput-short",
/* 52 */	"iget",
/* 53 */	"iget-wide",
/* 54 */	"iget-object",
/* 55 */	"iget-boolean",
/* 56 */	"iget-byte",
/* 57 */	"iget-char",
/* 58 */	"iget-short",
/* 59 */	"iput",
/* 5a */	"iput-wide",
/* 5b */	"iput-object",
/* 5c */	"iput-boolean",
/* 5d */	"iput-byte",
/* 5e */	"iput-char",
/* 5f */	"iput-short",
/* 60 */	"sget",
/* 61 */	"sget-wide",
/* 62 */	"sget-object",
/* 63 */	"sget-boolean",
/* 64 */	"sget-byte",
/* 65 */	"sget-char",
/* 66 */	"sget-short",
/* 67 */	"sput",
/* 68 */	"sput-wide",
/* 69 */	"sput-object",
/* 6a */	"sput-boolean",
/* 6b */	"sput-byte",
/* 6c */	"sput-char",
/* 6d */	"sput-short",
/* 6e */	"invoke-virtual",
/* 6f */	"invoke-super",
/* 70 */	"invoke-direct",
/* 71 */	"invoke-static",
/* 72 */	"invoke-interface",
/* 73 */	0,
/* 74 */	"invoke-virtual/range",
/* 75 */	"invoke-super/range",
/* 76 */	"invoke-direct/range",
/* 77 */	"invoke-static/range",
/* 78 */	"invoke-interface/range",
/* 79 */	0,
/* 7a */	0,
/* 7b */	"neg-int",
/* 7c */	"not-int",
/* 7d */	"neg-long",
/* 7e */	"not-long",
/* 7f */	"neg-float",
/* 80 */	"neg-double",
/* 81 */	"int-to-long",
/* 82 */	"int-to-float",
/* 83 */	"int-to-double",
/* 84 */	"long-to-int",
/* 85 */	"long-to-float",
/* 86 */	"long-to-double",
/* 87 */	"float-to-int",
/* 88 */	"float-to-long",
/* 89 */	"float-to-double",
/* 8a */	"double-to-int",
/* 8b */	"double-to-long",
/* 8c */	"double-to-float",
/* 8d */	"int-to-byte",
/* 8e */	"int-to-char",
/* 8f */	"int-to-short",
/* 90 */	"add-int",
/* 91 */	"sub-int",
/* 92 */	"mul-int",
/* 93 */	"div-int",
/* 94 */	"rem-int",
/* 95 */	"and-int",
/* 96 */	"or-int",
/* 97 */	"xor-int",
/* 98 */	"shl-int",
/* 99 */	"shr-int",
/* 9a */	"ushr-int",
/* 9b */	"add-long",
/* 9c */	"sub-long",
/* 9d */	"mul-long",
/* 9e */	"div-long",
/* 9f */	"rem-long",
/* a0 */	"and-long",
/* a1 */	"or-long",
/* a2 */	"xor-long",
/* a3 */	"shl-long",
/* a4 */	"shr-long",
/* a5 */	"ushr-long",
/* a6 */	"add-float",
/* a7 */	"sub-float",
/* a8 */	"mul-float",
/* a9 */	"div-float",
/* aa */	"rem-float",
/* ab */	"add-double",
/* ac */	"sub-double",
/* ad */	"mul-double",
/* ae */	"div-double",
/* af */	"rem-double",
/* b0 */	"add-int/2addr",
/* b1 */	"sub-int/2addr",
/* b2 */	"mul-int/2addr",
/* b3 */	"div-int/2addr",
/* b4 */	"rem-int/2addr",
/* b5 */	"and-int/2addr",
/* b6 */	"or-int/2addr",
/* b7 */	"xor-int/2addr",
/* b8 */	"shl-int/2addr",
/* b9 */	"shr-int/2addr",
/* ba */	"ushr-int/2addr",
/* bb */	"add-long/2addr",
/* bc */	"sub-long/2addr",
/* bd */	"mul-long/2addr",
/* be */	"div-long/2addr",
/* bf */	"rem-long/2addr",
/* c0 */	"and-long/2addr",
/* c1 */	"or-long/2addr",
/* c2 */	"xor-long/2addr",
/* c3 */	"shl-long/2addr",
/* c4 */	"shr-long/2addr",
/* c5 */	"ushr-long/2addr",
/* c6 */	"add-float/2addr",
/* c7 */	"sub-float/2addr",
/* c8 */	"mul-float/2addr",
/* c9 */	"div-float/2addr",
/* ca */	"rem-float/2addr",
/* cb */	"add-double/2addr",
/* cc */	"sub-double/2addr",
/* cd */	"mul-double/2addr",
/* ce */	"div-double/2addr",
/* cf */	"rem-double/2addr",
/* d0 */	"add-int/lit16",
/* d1 */	"rsub-int",
/* d2 */	"mul-int/lit16",
/* d3 */	"div-int/lit16",
/* d4 */	"rem-int/lit16",
/* d5 */	"and-int/lit16",
/* d6 */	"or-int/lit16",
/* d7 */	"xor-int/lit16",
/* d8 */	"add-int/lit8",
/* d9 */	"rsub-int/lit8",
/* da */	"mul-int/lit8",
/* db */	"div-int/lit8",
/* dc */	"rem-int/lit8",
/* dd */	"and-int/lit8",
/* de */	"or-int/lit8",
/* df */	"xor-int/lit8",
/* e0 */	"shl-int/lit8",
/* e1 */	"shr-int/lit8",
/* e2 */	"ushr-int/lit8",
/* e3 */	0,
/* e4 */	0,
/* e5  */	0,
/* e6 */	0,
/* e7 */	0,
/* e8 */	0,
/* e9 */	0,
/* ea */	0,
/* eb */	0,
/* ec */	0,
/* ed */	0,
/* ee */	0,
/* ef */	0,
/* f0 */	0,
/* f1 */	0,
/* f2 */	0,
/* f3  */	0,
/* f4 */	0,
/* f5  */	0,
/* f6 */	0,
/* f7 */	0,
/* f8 */	0,
/* f9 */	0,
/* fa */	0,
/* fb */	0,
/* fc */	0,
/* fd */	0,
/* fe */	"END-TRY",
/* ff */	"TRY",
};
